# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class AddCosignerResponse(BaseModel):
    """
    AddCosignerResponse
    """ # noqa: E501
    api_key_id: StrictStr = Field(description="The id of the API key to be paired with the cosigner", alias="apiKeyId")
    name: Annotated[str, Field(min_length=1, strict=True)] = Field(description="The name of the cosigner")
    existing_cosigner: Optional[StrictBool] = Field(default=False, description="Whether the cosigner already exists in another workspace", alias="existingCosigner")
    pending_cosigner_id: StrictStr = Field(description="The unique identifier of a pending cosigner", alias="pendingCosignerId")
    __properties: ClassVar[List[str]] = ["apiKeyId", "name", "existingCosigner", "pendingCosignerId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AddCosignerResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AddCosignerResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "apiKeyId": obj.get("apiKeyId"),
            "name": obj.get("name"),
            "existingCosigner": obj.get("existingCosigner") if obj.get("existingCosigner") is not None else False,
            "pendingCosignerId": obj.get("pendingCosignerId")
        })
        return _obj


