# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateMultipleDepositAddressesRequest(BaseModel):
    """
    CreateMultipleDepositAddressesRequest
    """ # noqa: E501
    vault_account_id: StrictInt = Field(description="Existing Vault account ID to add deposit addresses to", alias="vaultAccountId")
    asset_id: StrictStr = Field(description="asset ID", alias="assetId")
    count: StrictInt = Field(description="Count of deposit addresses to issue")
    descriptions: Optional[List[StrictStr]] = Field(default=None, description="Desctiptions of the newly created addresses")
    vault_account_to_copy_desc_from: Optional[StrictInt] = Field(default=None, description="Existing Vault Account ID to copy deposit addresses descriptions from in case no descriptions were provided", alias="vaultAccountToCopyDescFrom")
    vault_account_to_copy_desc_from_index: Optional[StrictInt] = Field(default=None, description="Existing length within the vault account to copy deposit addresses descriptions from", alias="vaultAccountToCopyDescFromIndex")
    __properties: ClassVar[List[str]] = ["vaultAccountId", "assetId", "count", "descriptions", "vaultAccountToCopyDescFrom", "vaultAccountToCopyDescFromIndex"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateMultipleDepositAddressesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateMultipleDepositAddressesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "vaultAccountId": obj.get("vaultAccountId"),
            "assetId": obj.get("assetId"),
            "count": obj.get("count"),
            "descriptions": obj.get("descriptions"),
            "vaultAccountToCopyDescFrom": obj.get("vaultAccountToCopyDescFrom"),
            "vaultAccountToCopyDescFromIndex": obj.get("vaultAccountToCopyDescFromIndex")
        })
        return _obj


