# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.parameter_with_value import ParameterWithValue
from typing import Optional, Set
from typing_extensions import Self

class MultichainDeploymentMetadata(BaseModel):
    """
    The multichain deployment metadata
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the deployment metadata")
    address: Optional[StrictStr] = Field(default=None, description="The address of the deployed contract")
    template_id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the contract template", alias="templateId")
    deployment_salt: Optional[StrictStr] = Field(default=None, description="The salt used for the deployment", alias="deploymentSalt")
    init_params: Optional[List[ParameterWithValue]] = Field(default=None, alias="initParams")
    encoded_init_params: Optional[StrictStr] = Field(default=None, description="The encoded init params", alias="encodedInitParams")
    __properties: ClassVar[List[str]] = ["id", "address", "templateId", "deploymentSalt", "initParams", "encodedInitParams"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MultichainDeploymentMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in init_params (list)
        _items = []
        if self.init_params:
            for _item_init_params in self.init_params:
                if _item_init_params:
                    _items.append(_item_init_params.to_dict())
            _dict['initParams'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MultichainDeploymentMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "address": obj.get("address"),
            "templateId": obj.get("templateId"),
            "deploymentSalt": obj.get("deploymentSalt"),
            "initParams": [ParameterWithValue.from_dict(_item) for _item in obj["initParams"]] if obj.get("initParams") is not None else None,
            "encodedInitParams": obj.get("encodedInitParams")
        })
        return _obj


