# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.travel_rule_date_and_place_of_birth import TravelRuleDateAndPlaceOfBirth
from fireblocks.models.travel_rule_geographic_address import TravelRuleGeographicAddress
from fireblocks.models.travel_rule_national_identification import TravelRuleNationalIdentification
from fireblocks.models.travel_rule_natural_person_name_identifier import TravelRuleNaturalPersonNameIdentifier
from typing import Optional, Set
from typing_extensions import Self

class TravelRuleNaturalPerson(BaseModel):
    """
    TravelRuleNaturalPerson
    """ # noqa: E501
    name: Optional[List[TravelRuleNaturalPersonNameIdentifier]] = Field(default=None, description="An array of structured name identifiers for the natural person, referencing the TravelRuleNaturalPersonNameIdentifier schema.")
    geographic_address: Optional[List[TravelRuleGeographicAddress]] = Field(default=None, description="An array of geographic addresses associated with the natural person, referencing the TravelRuleGeographicAddress schema.", alias="geographicAddress")
    national_identification: Optional[TravelRuleNationalIdentification] = Field(default=None, alias="nationalIdentification")
    date_and_place_of_birth: Optional[TravelRuleDateAndPlaceOfBirth] = Field(default=None, alias="dateAndPlaceOfBirth")
    customer_identification: Optional[StrictStr] = Field(default=None, description="A unique identifier for the customer within the organization's context. The value must be encrypted.", alias="customerIdentification")
    country_of_residence: Optional[StrictStr] = Field(default=None, description="The ISO-3166 Alpha-2 country code of the natural person's residence. The value must be encrypted.", alias="countryOfResidence")
    customer_number: Optional[StrictStr] = Field(default=None, description="A distinct identifier that uniquely identifies the customer within the organization. The value must be encrypted.", alias="customerNumber")
    __properties: ClassVar[List[str]] = ["name", "geographicAddress", "nationalIdentification", "dateAndPlaceOfBirth", "customerIdentification", "countryOfResidence", "customerNumber"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TravelRuleNaturalPerson from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in name (list)
        _items = []
        if self.name:
            for _item_name in self.name:
                if _item_name:
                    _items.append(_item_name.to_dict())
            _dict['name'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in geographic_address (list)
        _items = []
        if self.geographic_address:
            for _item_geographic_address in self.geographic_address:
                if _item_geographic_address:
                    _items.append(_item_geographic_address.to_dict())
            _dict['geographicAddress'] = _items
        # override the default output from pydantic by calling `to_dict()` of national_identification
        if self.national_identification:
            _dict['nationalIdentification'] = self.national_identification.to_dict()
        # override the default output from pydantic by calling `to_dict()` of date_and_place_of_birth
        if self.date_and_place_of_birth:
            _dict['dateAndPlaceOfBirth'] = self.date_and_place_of_birth.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TravelRuleNaturalPerson from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": [TravelRuleNaturalPersonNameIdentifier.from_dict(_item) for _item in obj["name"]] if obj.get("name") is not None else None,
            "geographicAddress": [TravelRuleGeographicAddress.from_dict(_item) for _item in obj["geographicAddress"]] if obj.get("geographicAddress") is not None else None,
            "nationalIdentification": TravelRuleNationalIdentification.from_dict(obj["nationalIdentification"]) if obj.get("nationalIdentification") is not None else None,
            "dateAndPlaceOfBirth": TravelRuleDateAndPlaceOfBirth.from_dict(obj["dateAndPlaceOfBirth"]) if obj.get("dateAndPlaceOfBirth") is not None else None,
            "customerIdentification": obj.get("customerIdentification"),
            "countryOfResidence": obj.get("countryOfResidence"),
            "customerNumber": obj.get("customerNumber")
        })
        return _obj


