# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class TravelRuleValidateNationalIdentification(BaseModel):
    """
    Represents a national identifier for a person or entity
    """ # noqa: E501
    country_of_issue: Optional[StrictStr] = Field(default=None, description="Country that issued the national identifier (ISO-3166 Alpha-2 country code)", alias="countryOfIssue")
    national_identifier: Optional[Annotated[str, Field(strict=True, max_length=35)]] = Field(default=None, description="National identifier (max 35 characters)", alias="nationalIdentifier")
    national_identifier_type: Optional[StrictStr] = Field(default=None, description="Type of national identifier. Acceptable values include: - 'PASSPORT': Passport number - 'NATIONAL_ID': National identification number - 'TAX_ID': Tax identification number - 'SOCIAL_SECURITY': Social security number", alias="nationalIdentifierType")
    registration_authority: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Registration authority (format -> RA followed by 6 digits)", alias="registrationAuthority")
    __properties: ClassVar[List[str]] = ["countryOfIssue", "nationalIdentifier", "nationalIdentifierType", "registrationAuthority"]

    @field_validator('national_identifier_type')
    def national_identifier_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['PASSPORT', 'NATIONAL_ID', 'TAX_ID', 'SOCIAL_SECURITY']):
            raise ValueError("must be one of enum values ('PASSPORT', 'NATIONAL_ID', 'TAX_ID', 'SOCIAL_SECURITY')")
        return value

    @field_validator('registration_authority')
    def registration_authority_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^RA\d{6}$", value):
            raise ValueError(r"must validate the regular expression /^RA\d{6}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TravelRuleValidateNationalIdentification from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TravelRuleValidateNationalIdentification from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "countryOfIssue": obj.get("countryOfIssue"),
            "nationalIdentifier": obj.get("nationalIdentifier"),
            "nationalIdentifierType": obj.get("nationalIdentifierType"),
            "registrationAuthority": obj.get("registrationAuthority")
        })
        return _obj


