# coding: utf-8

"""
    Fireblocks API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.6.2
    Contact: support@fireblocks.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from fireblocks.models.aml_registration_result_full_payload import AmlRegistrationResultFullPayload
from fireblocks.models.compliance_result_statuses_enum import ComplianceResultStatusesEnum
from fireblocks.models.compliance_screening_result_full_payload import ComplianceScreeningResultFullPayload
from typing import Optional, Set
from typing_extensions import Self

class ComplianceResultFullPayload(BaseModel):
    """
    The result of the Compliance AML/Travel Rule screening.
    """ # noqa: E501
    aml: Optional[ComplianceScreeningResultFullPayload] = None
    tr: Optional[ComplianceScreeningResultFullPayload] = None
    aml_list: Optional[List[ComplianceScreeningResultFullPayload]] = Field(default=None, description="The list of all results of the AML screening.", alias="amlList")
    status: Optional[ComplianceResultStatusesEnum] = None
    aml_registration: Optional[AmlRegistrationResultFullPayload] = Field(default=None, alias="amlRegistration")
    __properties: ClassVar[List[str]] = ["aml", "tr", "amlList", "status", "amlRegistration"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ComplianceResultFullPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aml
        if self.aml:
            _dict['aml'] = self.aml.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tr
        if self.tr:
            _dict['tr'] = self.tr.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in aml_list (list)
        _items = []
        if self.aml_list:
            for _item_aml_list in self.aml_list:
                if _item_aml_list:
                    _items.append(_item_aml_list.to_dict())
            _dict['amlList'] = _items
        # override the default output from pydantic by calling `to_dict()` of aml_registration
        if self.aml_registration:
            _dict['amlRegistration'] = self.aml_registration.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ComplianceResultFullPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aml": ComplianceScreeningResultFullPayload.from_dict(obj["aml"]) if obj.get("aml") is not None else None,
            "tr": ComplianceScreeningResultFullPayload.from_dict(obj["tr"]) if obj.get("tr") is not None else None,
            "amlList": [ComplianceScreeningResultFullPayload.from_dict(_item) for _item in obj["amlList"]] if obj.get("amlList") is not None else None,
            "status": obj.get("status"),
            "amlRegistration": AmlRegistrationResultFullPayload.from_dict(obj["amlRegistration"]) if obj.get("amlRegistration") is not None else None
        })
        return _obj


